/*
 * AR-3c kernel - xbat.h
 * 
 * Copyright (C) 2010  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef AR3C_XBAT_H_INCLUDED
#define AR3C_XBAT_H_INCLUDED

#if defined(HAVE_INTTYPES_H)
#include <inttypes.h>
#elif defined(HAVE_STDINT_H)
#include <stdint.h>
#else
typedef unsigned short __uint16_t;
typedef unsigned char __uint8_t;
#endif

struct xbat_header {
	__uint8_t version;	/* header version, 0 for this version */
	__uint8_t proto;	/* user protocol */
	__uint16_t length;	/* total record length, including header */
} __attribute__((packed));

enum {
	XBAT_PROTO_RAMBAT,		/* rambat records */
	XBAT_PROTO_RAMBAT_CRC16,	/* rambat records with CRC16 */
};

#define XBAT_ALIGNMENT		4
#define XBAT_ALIGN_MASK		3

#define xbat_align(x)	(((x) + XBAT_ALIGNMENT - 1) & ~XBAT_ALIGN_MASK)

#endif
